/* au file ôʬ
 * shige
 * 05/29 2000
 * sndio.c
 *
 * $Id: sndio.c,v 1.9 2004-01-07 16:00:52+09 shige Exp $
 */
/* 05/29 200
 * 1)	 auconn.c ˤäΤʬΥ
 * 2)	Τˡؿλͤľ
 */
#ifndef __SNDIO_C__
#define __SNDIO_C__

#include "sndio.h"

/* #define DEBUG1 */
/* #define DEBUG2 */

/* au file  header μ */
int getSndheader(FILE *file,Snddata *Snd)
{
    fseek(file,0,SEEK_SET);
    if(read4bytetoi(file,&(Snd->magic))<0
       || read4bytetoi(file,&(Snd->hlen))<0
       || read4bytetoi(file,&(Snd->datalen))<0
       || read4bytetoi(file,&(Snd->fmcode))<0
       || read4bytetoi(file,&(Snd->smplrate))<0
       || read4bytetoi(file,&(Snd->channel))<0)
      return Err_read4bytetoi;
    Snd->str=NULL;
#ifdef DEBUG1
    fprintf(stderr,"(magic,hlen,datalen,fmcode,smplrate,channel)=");
    fprintf(stderr,"(%d,%d,%d,%d,%d,%d)\n",Snd->magic,Snd->hlen,
	    Snd->datalen,Snd->fmcode,Snd->smplrate,Snd->channel);
#endif /* DEBUG1 */
    return No_err;
}

int getSndheader_noseek(FILE *file,Snddata *Snd)
{
    long int j;

    if(read4bytetoi(file,&(Snd->magic))<0
       || read4bytetoi(file,&(Snd->hlen))<0
       || read4bytetoi(file,&(Snd->datalen))<0
       || read4bytetoi(file,&(Snd->fmcode))<0
       || read4bytetoi(file,&(Snd->smplrate))<0
       || read4bytetoi(file,&(Snd->channel))<0)
      return Err_read4bytetoi;
    Snd->str=NULL;
#ifdef DEBUG1
    fprintf(stderr,"(magic,hlen,datalen,fmcode,smplrate,channel)=");
    fprintf(stderr,"(%d,%d,%d,%d,%d,%d)\n",Snd->magic,Snd->hlen,
	    Snd->datalen,Snd->fmcode,Snd->smplrate,Snd->channel);
#endif /* DEBUG1 */
    for(j=25;j<=Snd->hlen;j++) fgetc(file);
    return No_err;
}

int getSndheader_noseek2(FILE *file,Snddata *Snd)
{
    long int j;

    if(read4bytetoi(file,&(Snd->hlen))<0
       || read4bytetoi(file,&(Snd->datalen))<0
       || read4bytetoi(file,&(Snd->fmcode))<0
       || read4bytetoi(file,&(Snd->smplrate))<0
       || read4bytetoi(file,&(Snd->channel))<0)
      return Err_read4bytetoi;
    Snd->str=NULL;
#ifdef DEBUG1
    fprintf(stderr,"(magic,hlen,datalen,fmcode,smplrate,channel)=");
    fprintf(stderr,"(%d,%d,%d,%d,%d,%d)\n",Snd->magic,Snd->hlen,
	    Snd->datalen,Snd->fmcode,Snd->smplrate,Snd->channel);
#endif /* DEBUG1 */
    for(j=25;j<=Snd->hlen;j++) fgetc(file);
    return No_err;
}

/* Snd header  */
int chSndheader(Snddata *Snd1,Snddata *Snd2)
{
    if(Snd1->magic != Snd2->magic) return Err_diffmagic;
    if(Snd1->fmcode != Snd2->fmcode) return Err_diffmcode;
    if(Snd1->smplrate != Snd2->smplrate) return Err_diffsmplrate;
    if(Snd1->channel != Snd2->channel) return Err_diffchannel;
    return No_err;
}

/* Snd header  */
int chSndheaderMASK(Snddata *Snd1,Snddata *Snd2,int mask)
{
    if(mask&AU_MAGIC && Snd1->magic != Snd2->magic) 
      return Err_diffmagic;
    if(mask&AU_FMCODE && Snd1->fmcode != Snd2->fmcode) 
      return Err_diffmcode;
    if(mask&AU_SMPLRATE && Snd1->smplrate != Snd2->smplrate) 
      return Err_diffsmplrate;
    if(mask&AU_CHANNEL && Snd1->channel != Snd2->channel) 
      return Err_diffchannel;
    return No_err;
}

/* Snd[] Ĥʤ file  header ν */
void putallheader(FILE *file,Snddata *Snd,int N)
{
    int j;
    int datalen=0;

    writeito4byte(file,Snd[0].magic);
    writeito4byte(file,32);
    for(j=1;j<=N;j++) datalen+=Snd[j-1].datalen;
    writeito4byte(file,datalen);
    writeito4byte(file,Snd[0].fmcode);
    writeito4byte(file,Snd[0].smplrate);
    writeito4byte(file,Snd[0].channel);
    writeito4byte(file,0);
    writeito4byte(file,0);
}

/* Ĺ + Ψ; 2  */
void putallheader3(FILE *file,Snddata *Snd,int N,int len,int addsp,double times)
{
    int j;
    int datalen=0,Nlen;

    writeito4byte(file,Snd[0].magic);
    writeito4byte(file,32);
    for(j=1;j<=N;j++){
	Nlen=(times>0.0)? Snd[j-1].datalen/times:Snd[j-1].datalen;
	datalen+=(len>0 && (addsp||Nlen>=len))?len:Nlen;
    }
    writeito4byte(file,datalen);
    writeito4byte(file,Snd[0].fmcode);
    writeito4byte(file,Snd[0].smplrate);
    writeito4byte(file,Snd[0].channel);
    writeito4byte(file,0);
    writeito4byte(file,0);
}

/* Ĺ + Ψ; 2  */
void putallheader4(FILE *file,Snddata *Snd,int N,ConnOpt *opt)
{
    int j;
    int datalen=0,Nlen;
    int len,addsp;
    double times;

    writeito4byte(file,Snd[0].magic);
    writeito4byte(file,32);
    for(j=1;j<=N;j++){
	len=opt[j-1].len; addsp=opt[j-1].addsp; times=opt[j-1].times;
	Nlen=(times>0.0)? Snd[j-1].datalen/times:Snd[j-1].datalen;
	datalen+=(len>0 && (addsp||Nlen>=len))?len:Nlen;
    }
    writeito4byte(file,datalen);
    writeito4byte(file,Snd[0].fmcode);
    writeito4byte(file,Snd[0].smplrate);
    writeito4byte(file,Snd[0].channel);
    writeito4byte(file,0);
    writeito4byte(file,0);
}

/* olen: ºݤνĹ, times: Ψ (times>0)
 */
void puttrans(FILE *infile,FILE *outfile,Snddata *snd,int olen,double times)
{
    long int j;
    int dlen=snd->datalen;
    int x0,x,count=0;
    double t=0.0;

    if(times<0.0){
	putfile2file(infile,outfile,snd->hlen,olen);
	return;
    }
    fseek(infile,snd->hlen,SEEK_SET);
    x0=ulaw2linear(fgetc(infile));
    for(j=2;j<=dlen;j++){
	x=ulaw2linear(fgetc(infile));
	while(t<=1.0){
	    fputc(linear2ulaw(x0*(1.0-t)+x*t),outfile);
	    if(++count>=olen) return;
	    t+=times;
	}
	t-=1.0;
	x0=x;
    }
    /* ¿ʬۤ */
    for(;count<=olen;count++) fputc(linear2ulaw(x),outfile);
}

#endif /* __SNDIO_C__ */
