/* au file ôʬΥإåե
 * shige
 * 05/29 2000
 * sndio.h
 * 
 * $Id: sndio.h,v 1.10 2003-12-30 01:25:13+09 shige Exp $
 */
#ifndef __SNDIO_H__
#define __SNDIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "error.h"
#include "fileio.h"
#include "g711.h"
#include "cstruct.h"

typedef struct {
    long int magic;	/* magic number SND_MAGIC */
    long int hlen;	/* data  offset */
    long int datalen;	/* data Ĺ */
    long int fmcode;	/* data format code */
    long int smplrate;	/* sampling rate */
    long int channel;	/* channel  */
    char *str;	/* Ǥդʸ */
} Snddata;

/* ̵ǡ */
#define AUNULL (0x7e)
/* AUSCALE: |粻|
 */
#define AUSCALE 32124.0

/* for chSndheaderMASK() */
#define AU_MAGIC	0x0001
#define AU_FMCODE	0x0002
#define AU_CHANNEL	0x0004
#define AU_SMPLRATE	0x0008

#ifdef __SNDIO_C__
# define EXTERN_SNDIO 
#else
# define EXTERN_SNDIO extern 
#endif

EXTERN_SNDIO int getSndheader(FILE *file,Snddata *Snd);
EXTERN_SNDIO int getSndheader_noseek(FILE *file,Snddata *Snd);
EXTERN_SNDIO int getSndheader_noseek2(FILE *file,Snddata *Snd);
EXTERN_SNDIO int chSndheader(Snddata *Snd1,Snddata *Snd2);
EXTERN_SNDIO int chSndheaderMASK(Snddata *Snd1,Snddata *Snd2,int mask);
EXTERN_SNDIO void putallheader(FILE *file,Snddata *Snd,int N);
EXTERN_SNDIO void putallheader3(FILE *file,Snddata *Snd,int N,int len,int addsp,
				double times);
EXTERN_SNDIO void putallheader4(FILE *file,Snddata *Snd,int N,ConnOpt *opt);
EXTERN_SNDIO void puttrans(FILE *infile,FILE *outfile,Snddata *snd,int olen,
			   double times);
#endif /* __SNDIO_H__ */
